(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('rxjs/operators'), require('echarts'), require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-echarts-net', ['exports', 'rxjs', 'rxjs/operators', 'echarts', '@angular/core', '@angular/common'], factory) :
    (factory((global['ngx-echarts-net'] = {}),global.rxjs,global.rxjs.operators,global.echarts,global.ng.core,global.ng.common));
}(this, (function (exports,rxjs,operators,echarts,core,common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */
    var NgxEchartsComponent = /** @class */ (function () {
        function NgxEchartsComponent(el, ngZone) {
            this.el = el;
            this.ngZone = ngZone;
            this.setOptionConfig = {
                notMerge: true
            };
            this.loadingType = 'default';
            this.autoResize = false;
            this.onInit = new core.EventEmitter();
            this.onOptionChange = new core.EventEmitter();
            // events
            this.onClick = new core.EventEmitter();
            this.onDblClick = new core.EventEmitter();
            this.onMouseDown = new core.EventEmitter();
            this.onMouseMove = new core.EventEmitter();
            this.onMouseUp = new core.EventEmitter();
            this.onMouseOver = new core.EventEmitter();
            this.onMouseOut = new core.EventEmitter();
            this.onGlobalOut = new core.EventEmitter();
            this.onContextMenu = new core.EventEmitter();
            // action events
            this.onLegendSelectChanged = new core.EventEmitter();
            this.onLegendSelected = new core.EventEmitter();
            this.onLegendUnSelected = new core.EventEmitter();
            this.onLegendScroll = new core.EventEmitter();
            this.onDataZoom = new core.EventEmitter();
            this.onDataRangeSelected = new core.EventEmitter();
            this.onTimelineChanged = new core.EventEmitter();
            this.onTimelinePlayChanged = new core.EventEmitter();
            this.onRestore = new core.EventEmitter();
            this.onDataViewChanged = new core.EventEmitter();
            this.onMagicTypeChanged = new core.EventEmitter();
            this.onGeoSelectChanged = new core.EventEmitter();
            this.onGeoSelected = new core.EventEmitter();
            this.onGeoUnSelected = new core.EventEmitter();
            this.onPieSelectChanged = new core.EventEmitter();
            this.onPieSelected = new core.EventEmitter();
            this.onPieUnSelected = new core.EventEmitter();
            this.onMapSelectChanged = new core.EventEmitter();
            this.onMapSelected = new core.EventEmitter();
            this.onMapUnSelected = new core.EventEmitter();
            this.onAxisAreaSelected = new core.EventEmitter();
            this.onFocusNodeAdjacency = new core.EventEmitter();
            this.onUnfocusNodeAdjacency = new core.EventEmitter();
            this.onBrush = new core.EventEmitter();
            this.onBrushSelected = new core.EventEmitter();
            this.onGlobalCursorTaken = new core.EventEmitter();
            this.onRendered = new core.EventEmitter();
            this.onFinished = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        NgxEchartsComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.resize$ = rxjs.fromEvent(window, 'resize')
                    .pipe(operators.debounceTime(200))
                    .subscribe(function () { return _this.resize(); });
                this.init();
            };
        /**
         * @param {?} changes
         * @return {?}
         */
        NgxEchartsComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                if (changes["theme"] && !changes["theme"].isFirstChange()) {
                    this.dispose();
                    this.init();
                }
                if (changes["option"] && !changes["option"].isFirstChange()) {
                    if (this.echartsInstance) {
                        this.setOption();
                    }
                }
                if (changes["group"]) {
                    this.toggleGroup(changes["group"]);
                }
                if (changes["loading"]) {
                    this.toggleLoading();
                }
            };
        /**
         * @return {?}
         */
        NgxEchartsComponent.prototype.ngDoCheck = /**
         * @return {?}
         */
            function () {
                this.resize();
            };
        /**
         * @return {?}
         */
        NgxEchartsComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.dispose();
                if (this.resize$) {
                    this.resize$.unsubscribe();
                }
            };
        /**
         * @return {?}
         */
        NgxEchartsComponent.prototype.init = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (!this.echartsInstance) {
                    this.offsetWidth = this.el.nativeElement.offsetWidth;
                    this.offsetHeight = this.el.nativeElement.offsetHeight;
                    if (!(this.initOpts && this.initOpts.height) && this.offsetHeight === 0) {
                        this.el.nativeElement.style.height = '500px';
                    }
                    this.ngZone.runOutsideAngular(function () {
                        _this.echartsInstance = echarts.init(_this.host.nativeElement, _this.theme, _this.initOpts);
                        _this.onInit.emit(_this.echartsInstance);
                        _this.echartsInstance.group = _this.group;
                        _this.buildEvent();
                        _this.setOption();
                    });
                }
                else {
                    this.setOption();
                }
            };
        /**
         * @return {?}
         */
        NgxEchartsComponent.prototype.dispose = /**
         * @return {?}
         */
            function () {
                this.echartsInstance.dispose();
                this.echartsInstance = null;
            };
        /**
         * @return {?}
         */
        NgxEchartsComponent.prototype.setOption = /**
         * @return {?}
         */
            function () {
                if (this.option) {
                    this.echartsInstance.setOption(this.option, this.setOptionConfig);
                    this.onOptionChange.emit(this.option);
                }
            };
        /**
         * @param {?} change
         * @return {?}
         */
        NgxEchartsComponent.prototype.toggleGroup = /**
         * @param {?} change
         * @return {?}
         */
            function (change) {
                if (change.previousValue) {
                    echarts.disConnect(change.previousValue);
                }
                if (change.currentValue) {
                    echarts.connect(change.currentValue);
                }
            };
        /**
         * @return {?}
         */
        NgxEchartsComponent.prototype.toggleLoading = /**
         * @return {?}
         */
            function () {
                if (this.echartsInstance) {
                    if (this.loading) {
                        this.echartsInstance.showLoading(this.loadingType, this.loadingOpts);
                    }
                    else {
                        this.echartsInstance.hideLoading();
                    }
                }
            };
        /**
         * @return {?}
         */
        NgxEchartsComponent.prototype.buildEvent = /**
         * @return {?}
         */
            function () {
                var _this = this;
                // events
                this.echartsInstance.on('click', function (event) { return _this.ngZone.run(function () { return _this.onClick.emit(event); }); });
                this.echartsInstance.on('dblclick', function (event) { return _this.ngZone.run(function () { return _this.onDblClick.emit(event); }); });
                this.echartsInstance.on('mousedown', function (event) { return _this.ngZone.run(function () { return _this.onMouseDown.emit(event); }); });
                this.echartsInstance.on('mousemove', function (event) { return _this.ngZone.run(function () { return _this.onMouseMove.emit(event); }); });
                this.echartsInstance.on('mouseup', function (event) { return _this.ngZone.run(function () { return _this.onMouseUp.emit(event); }); });
                this.echartsInstance.on('mouseover', function (event) { return _this.ngZone.run(function () { return _this.onMouseOver.emit(event); }); });
                this.echartsInstance.on('mouseout', function (event) { return _this.ngZone.run(function () { return _this.onMouseOut.emit(event); }); });
                this.echartsInstance.on('globalout', function (event) { return _this.ngZone.run(function () { return _this.onGlobalOut.emit(event); }); });
                this.echartsInstance.on('contextmenu', function (event) { return _this.ngZone.run(function () { return _this.onContextMenu.emit(event); }); });
                // action events
                this.echartsInstance.on('legendselectchanged', function (event) { return _this.ngZone.run(function () { return _this.onLegendSelectChanged.emit(event); }); });
                this.echartsInstance.on('legendselected', function (event) { return _this.ngZone.run(function () { return _this.onLegendSelected.emit(event); }); });
                this.echartsInstance.on('legendunselected', function (event) { return _this.ngZone.run(function () { return _this.onLegendUnSelected.emit(event); }); });
                this.echartsInstance.on('legendscroll', function (event) { return _this.ngZone.run(function () { return _this.onLegendScroll.emit(event); }); });
                this.echartsInstance.on('datazoom', function (event) { return _this.ngZone.run(function () { return _this.onDataZoom.emit(event); }); });
                this.echartsInstance.on('datarangeselected', function (event) { return _this.ngZone.run(function () { return _this.onDataRangeSelected.emit(event); }); });
                this.echartsInstance.on('timelinechanged', function (event) { return _this.ngZone.run(function () { return _this.onTimelineChanged.emit(event); }); });
                this.echartsInstance.on('timelineplaychanged', function (event) { return _this.ngZone.run(function () { return _this.onTimelinePlayChanged.emit(event); }); });
                this.echartsInstance.on('restore', function (event) { return _this.ngZone.run(function () { return _this.onRestore.emit(event); }); });
                this.echartsInstance.on('dataviewchanged', function (event) { return _this.ngZone.run(function () { return _this.onDataViewChanged.emit(event); }); });
                this.echartsInstance.on('magictypechanged', function (event) { return _this.ngZone.run(function () { return _this.onMagicTypeChanged.emit(event); }); });
                this.echartsInstance.on('geoselectchanged', function (event) { return _this.ngZone.run(function () { return _this.onGeoSelectChanged.emit(event); }); });
                this.echartsInstance.on('geoselected', function (event) { return _this.ngZone.run(function () { return _this.onGeoSelected.emit(event); }); });
                this.echartsInstance.on('geounselected', function (event) { return _this.ngZone.run(function () { return _this.onGeoUnSelected.emit(event); }); });
                this.echartsInstance.on('pieselectchanged', function (event) { return _this.ngZone.run(function () { return _this.onPieSelectChanged.emit(event); }); });
                this.echartsInstance.on('pieselected', function (event) { return _this.ngZone.run(function () { return _this.onPieSelected.emit(event); }); });
                this.echartsInstance.on('pieunselected', function (event) { return _this.ngZone.run(function () { return _this.onPieUnSelected.emit(event); }); });
                this.echartsInstance.on('mapselectchanged', function (event) { return _this.ngZone.run(function () { return _this.onMapSelectChanged.emit(event); }); });
                this.echartsInstance.on('mapselected', function (event) { return _this.ngZone.run(function () { return _this.onMapSelected.emit(event); }); });
                this.echartsInstance.on('mapunselected', function (event) { return _this.ngZone.run(function () { return _this.onMapUnSelected.emit(event); }); });
                this.echartsInstance.on('axisareaselected', function (event) { return _this.ngZone.run(function () { return _this.onAxisAreaSelected.emit(event); }); });
                this.echartsInstance.on('focusNodeAdjacency', function (event) { return _this.ngZone.run(function () { return _this.onFocusNodeAdjacency.emit(event); }); });
                this.echartsInstance.on('unfocusNodeAdjacency', function (event) { return _this.ngZone.run(function () { return _this.onUnfocusNodeAdjacency.emit(event); }); });
                this.echartsInstance.on('brush', function (event) { return _this.ngZone.run(function () { return _this.onBrush.emit(event); }); });
                this.echartsInstance.on('brushselected', function (event) { return _this.ngZone.run(function () { return _this.onBrushSelected.emit(event); }); });
                this.echartsInstance.on('globalcursortaken', function (event) { return _this.ngZone.run(function () { return _this.onGlobalCursorTaken.emit(event); }); });
                this.echartsInstance.on('rendered', function (event) { return _this.ngZone.run(function () { return _this.onRendered.emit(event); }); });
                this.echartsInstance.on('finished', function (event) { return _this.ngZone.run(function () { return _this.onFinished.emit(event); }); });
            };
        /**
         * @return {?}
         */
        NgxEchartsComponent.prototype.resize = /**
         * @return {?}
         */
            function () {
                if (this.autoResize && this.echartsInstance) {
                    /** @type {?} */
                    var offsetWidth = this.el.nativeElement.offsetWidth;
                    /** @type {?} */
                    var offsetHeight = this.el.nativeElement.offsetHeight;
                    if (this.offsetWidth !== offsetWidth || this.offsetHeight !== offsetHeight) {
                        this.offsetWidth = offsetWidth;
                        this.offsetHeight = offsetHeight;
                        this.echartsInstance.resize();
                    }
                }
            };
        NgxEchartsComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-echarts',
                        template: "<div #host class=\"echarts-container\"></div>",
                        styles: [":host{display:block;height:100%}.echarts-container{height:100%}"]
                    }] }
        ];
        /** @nocollapse */
        NgxEchartsComponent.ctorParameters = function () {
            return [
                { type: core.ElementRef },
                { type: core.NgZone }
            ];
        };
        NgxEchartsComponent.propDecorators = {
            theme: [{ type: core.Input }],
            initOpts: [{ type: core.Input }],
            option: [{ type: core.Input }],
            group: [{ type: core.Input }],
            setOptionConfig: [{ type: core.Input }],
            loading: [{ type: core.Input }],
            loadingType: [{ type: core.Input }],
            loadingOpts: [{ type: core.Input }],
            autoResize: [{ type: core.Input }],
            onInit: [{ type: core.Output }],
            onOptionChange: [{ type: core.Output }],
            onClick: [{ type: core.Output }],
            onDblClick: [{ type: core.Output }],
            onMouseDown: [{ type: core.Output }],
            onMouseMove: [{ type: core.Output }],
            onMouseUp: [{ type: core.Output }],
            onMouseOver: [{ type: core.Output }],
            onMouseOut: [{ type: core.Output }],
            onGlobalOut: [{ type: core.Output }],
            onContextMenu: [{ type: core.Output }],
            onLegendSelectChanged: [{ type: core.Output }],
            onLegendSelected: [{ type: core.Output }],
            onLegendUnSelected: [{ type: core.Output }],
            onLegendScroll: [{ type: core.Output }],
            onDataZoom: [{ type: core.Output }],
            onDataRangeSelected: [{ type: core.Output }],
            onTimelineChanged: [{ type: core.Output }],
            onTimelinePlayChanged: [{ type: core.Output }],
            onRestore: [{ type: core.Output }],
            onDataViewChanged: [{ type: core.Output }],
            onMagicTypeChanged: [{ type: core.Output }],
            onGeoSelectChanged: [{ type: core.Output }],
            onGeoSelected: [{ type: core.Output }],
            onGeoUnSelected: [{ type: core.Output }],
            onPieSelectChanged: [{ type: core.Output }],
            onPieSelected: [{ type: core.Output }],
            onPieUnSelected: [{ type: core.Output }],
            onMapSelectChanged: [{ type: core.Output }],
            onMapSelected: [{ type: core.Output }],
            onMapUnSelected: [{ type: core.Output }],
            onAxisAreaSelected: [{ type: core.Output }],
            onFocusNodeAdjacency: [{ type: core.Output }],
            onUnfocusNodeAdjacency: [{ type: core.Output }],
            onBrush: [{ type: core.Output }],
            onBrushSelected: [{ type: core.Output }],
            onGlobalCursorTaken: [{ type: core.Output }],
            onRendered: [{ type: core.Output }],
            onFinished: [{ type: core.Output }],
            host: [{ type: core.ViewChild, args: ['host',] }]
        };
        return NgxEchartsComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */
    var NgxEchartsModule = /** @class */ (function () {
        function NgxEchartsModule() {
        }
        NgxEchartsModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule
                        ],
                        exports: [
                            NgxEchartsComponent,
                        ],
                        declarations: [
                            NgxEchartsComponent,
                        ]
                    },] }
        ];
        return NgxEchartsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */

    exports.NgxEchartsComponent = NgxEchartsComponent;
    exports.NgxEchartsModule = NgxEchartsModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-echarts-net.umd.js.map